package org.pwte.example.domain.tests;

import java.math.BigDecimal;

import junit.framework.TestCase;

import org.hibernate.classic.Session;
import org.pwte.example.domain.LineItem;
import org.pwte.example.domain.LineItemId;
import org.pwte.example.domain.Product;
import org.pwte.example.hibernate.HibernateUtil;

public class LineItemTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testLoadLineItems() {
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		
		Product sampleProduct = new Product();
		sampleProduct.setProductId(10);
		sampleProduct.setPrice(new BigDecimal(10.0));
		sampleProduct.setDescription("Hair Gel");
		
		LineItem sample = new LineItem();
		sample.setProduct(sampleProduct);
		sample.setAmount(new BigDecimal(10.0));
		sample.setQuantity(10);
		
		session.beginTransaction();
		
		LineItem retrieved = (LineItem) session.load(LineItem.class, new LineItemId(10,10));

		//assertEquals("amount not right", retrieved.getAmount(), sample.getAmount());
		System.out.println("amount is "+ retrieved.getAmount());
		assertEquals("quantity not right", retrieved.getQuantity(), sample.getQuantity());
		assertEquals("product not right", retrieved.getProduct().getDescription(), sample.getProduct().getDescription());
		
		session.getTransaction().commit();
	}

}
