package org.pwte.example.domain.tests;

import junit.framework.TestCase;

import org.hibernate.classic.Session;
import org.pwte.example.domain.AbstractCustomer;
import org.pwte.example.domain.BusinessCustomer;
import org.pwte.example.domain.Order;
import org.pwte.example.domain.Order.Status;
import org.pwte.example.hibernate.HibernateUtil;

public class OrderTest extends TestCase {

	protected void setUp() throws Exception {
		super.setUp();
	}

	protected void tearDown() throws Exception {
		super.tearDown();
	}
	
	public void testLoadOrder() {
		
		// Note this assumes that order number 10 is in the database 
		
		Session session = HibernateUtil.getSessionFactory().getCurrentSession();
		
		BusinessCustomer myCustomer = new BusinessCustomer();
		
		Order myOrder = new Order();
		myOrder.setStatus(Status.OPEN);
		myOrder.setOrderId(10);
		myOrder.setCustomer(myCustomer);
		
		session.beginTransaction();
		
		Order retrieved = (Order) session.load(Order.class, new Integer(10));

		assertEquals("orderid not right", retrieved.getOrderId(), myOrder.getOrderId());
		assertEquals("status not right", retrieved.getStatus(), myOrder.getStatus());
//		assertEquals("customer class not right", retrieved.getCustomer().getClass().toString(), myOrder.getCustomer().getClass().toString());
		AbstractCustomer cust = retrieved.getCustomer();
		System.out.println(cust.getName());
		//System.out.println(((BusinessCustomer)cust).getName());
		session.getTransaction().commit();
		assertEquals("line item count wrong", retrieved.getLineitems().size(), 1);
	}

}
