package org.pwte.example.jdbc.util;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ResourceBundle;

import org.pwte.example.exception.GeneralPersistenceException;

public class JDBCHelper 
{
	private static String driver = null;
	private static String dbName = null;
	
	
	static
	{
		ResourceBundle resources =
		      ResourceBundle.getBundle("org.pwte.example.jdbc.util.JDBCInfo");
		driver = resources.getString("driver");
		dbName = resources.getString("dbName");
	}
	
	
	public static Connection getJDBCConnection() throws SQLException,GeneralPersistenceException
    {
    	Connection connection = null;
    	String connectionURL = "jdbc:derby:" + dbName; 
    	try
    	{
    		Class.forName(driver); 
    	}
    	catch (ClassNotFoundException cnfe) 
    	{
    		throw new GeneralPersistenceException(cnfe);  		
    	}
    	connection = DriverManager.getConnection(connectionURL);
    	connection.setAutoCommit(false);
    	return connection;
    }
	
	public static  void closeStatement(Statement st)
	{
		try
		{
			if(st != null) st.close();
		} 
		catch (SQLException e) 
		{
			//log fail close
		}
	}
	
	public static void closeResultSet(ResultSet rs)
	{
		try
		{
			if(rs != null)rs.close();
		} 
		catch (SQLException e) 
		{
			//log fail close
		}
	}
	
	public static void closeConnection(Connection con)
	{
		try
		{
			if(con != null) con.close();
		} 
		catch (SQLException e) 
		{
			//log fail close
		}
	}
}
