package org.pwte.example.domain;

import java.io.Serializable;
import java.math.BigDecimal;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.IdClass;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import org.apache.openjpa.persistence.FetchAttribute;
import org.apache.openjpa.persistence.FetchGroup;
import org.apache.openjpa.persistence.FetchGroups;

@Entity
@Table(name="LINE_ITEM")
@IdClass(LineItemId.class)
@NamedQuery(name="existing.lineitem.forproduct",query="select l from LineItem l where l.productId = :productId and l.orderId = :orderId")

public class LineItem implements Serializable {
	private static final long serialVersionUID = -5969434202374976648L;
	
	
	
	@Id
	@Column(name="ORDER_ID")
	private int orderId;
	
	@Id
	@Column(name="PRODUCT_ID")
	private int productId;
	
	
	protected long quantity;
	protected BigDecimal amount;
	
	@ManyToOne(fetch = FetchType.EAGER)
	@JoinColumns({
		@JoinColumn(name="PRODUCT_ID", referencedColumnName = "PRODUCT_ID")})
	protected Product product;
	
	public LineItem(){super();}
	
	public LineItem(long quantity, BigDecimal amount, Product product) {
		super();
		this.quantity = quantity;
		this.amount = amount;
		this.product = product;
	}
	public BigDecimal getAmount() {return amount;}
	public void setAmount(BigDecimal amount) {this.amount = amount;}
	public Product getProduct() {return product;}
	public void setProduct(Product product) {this.product = product;}
	public long getQuantity() {return quantity;}
	public void setQuantity(long quantity) {this.quantity = quantity;}

	
	public int getOrderId() {
		return orderId;
	}

	public void setOrderId(int orderId) {
		this.orderId = orderId;
	}

	public int getProductId() {
		return productId;
	}

	public void setProductId(int productId) {
		this.productId = productId;
	}

	
}
