package org.pwte.example.domain;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.apache.openjpa.persistence.jdbc.ElementJoinColumn;


@Entity
@Table(name="ORDERS")

public class Order implements Serializable {
	private static final long serialVersionUID = 7779370942277849463L;
	
	
	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	@Column(name="ORDER_ID")
	protected int orderId;
	protected BigDecimal total;
	public static enum Status { OPEN, SUBMITTED, CLOSED }
	protected Status status;
	
	@ManyToOne
	@JoinColumn(name="CUSTOMER_ID", referencedColumnName = "CUSTOMER_ID")
	protected AbstractCustomer customer;
	
	@OneToMany(cascade=CascadeType.REMOVE,fetch=FetchType.EAGER )
	@ElementJoinColumn(name="ORDER_ID",referencedColumnName="ORDER_ID")
	protected Set<LineItem> lineitems;

	public AbstractCustomer getCustomer() {return customer;}
	public void setCustomer(AbstractCustomer customer) {this.customer = customer;}
	public Set<LineItem> getLineitems() {return lineitems;}
	public void setLineitems(Set<LineItem> lineitems) {this.lineitems = lineitems;}
	public int getOrderId() {return orderId;}
	public void setOrderId(int orderId) {this.orderId = orderId;}
	public Status getStatus() {return status;}
	public void setStatus(Status status) {this.status = status;}
	public BigDecimal getTotal() {return total;}
	public void setTotal(BigDecimal total) {this.total = total;}
}
