package org.pwte.example.domain;

import java.io.Serializable;
import java.util.Set;

import zero.data.handler.Join;

import com.ibm.pdq.annotation.Column;
import com.ibm.pdq.annotation.Id;
import com.ibm.pdq.annotation.Table;

@Table(name="CUSTOMER")
public abstract class AbstractCustomer implements Serializable {
	
	@Id
	@Column(name="CUSTOMER_ID")
	protected int customerId;
	
	@Column(name="NAME")
	protected String name;
	
	@Column(name="TYPE")
	protected String type;
	
	@Join
	protected Order openOrder;
	
	
	protected Set<Order> orders;

	public AbstractCustomer(){}
	
	public AbstractCustomer(String name, Order openOrder, Set<Order> orders) {
		super();
		this.name = name;
		this.openOrder = openOrder;
		this.orders = orders;
	}
	
	public int getCustomerId() {return customerId;}
	public void setCustomerId(int customerId) {this.customerId = customerId;}
	public String getName() {return name;}
	public void setName(String name) {this.name = name;}
	
	
	public Order getOpenOrder() {return openOrder;}
	public void setOpenOrder(Order openOrder) {this.openOrder = openOrder;}
	public Set<Order> getOrders() {return orders;}
	public void setOrders(Set<Order> orders) {this.orders = orders;}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

}
