package org.pwte.example.domain;

import java.io.Serializable;
import java.util.Set;

import com.ibm.pdq.annotation.Column;
import com.ibm.pdq.annotation.Table;

@Table(name="CUSTOMER")
public class BusinessCustomer extends AbstractCustomer implements Serializable {
	private static final long serialVersionUID = -1210978439928403907L;
	
	
	@Column(name="BUSINESS_VOLUME_DISCOUNT")
	protected boolean volumeDiscount; 
	
	@Column(name="BUSINESS_PARTNER")
	protected boolean businessPartner;
	
	@Column(name="BUSINESS_DESCRIPTION")
	protected String description;
	
	public BusinessCustomer(){super();}
	
	public BusinessCustomer(boolean volumeDiscount, boolean businessPartner, String description, String name, Order openOrder, Set<Order> orders) {
		super(name, openOrder, orders);
		this.volumeDiscount = volumeDiscount;
		this.businessPartner = businessPartner;
		this.description = description;
	}
	
	public boolean isBusinessPartner() {return businessPartner;}
	public void setBusinessPartner(boolean businessPartner) {this.businessPartner = businessPartner;}
	public String getDescription() {return description;}
	public void setDescription(String description) {this.description = description;}
	public boolean isVolumeDiscount() {return volumeDiscount;}
	public void setVolumeDiscount(boolean volumeDiscount) {this.volumeDiscount = volumeDiscount;}
}
