package org.pwte.example.domain;

import java.io.Serializable;
import java.math.BigDecimal;

import zero.data.handler.Join;

import com.ibm.pdq.annotation.Column;
import com.ibm.pdq.annotation.Id;
import com.ibm.pdq.annotation.Table;

@Table(name="LINE_ITEM")
public class LineItem implements Serializable {
	private static final long serialVersionUID = -5969434202374976648L;
	
	@Id
	@Column(name="ORDER_ID")
	protected int orderId;
	
	@Id
	@Column(name="PRODUCT_ID")
	protected int productId;
	
	
	@Column(name="QUANTITY")
	protected long quantity;
	
	@Column(name="AMOUNT")
	protected BigDecimal amount;
	
	
	@Join
	protected Product product;
	
	public LineItem(){super();}
	
	public LineItem(long quantity, BigDecimal amount, Product product) {
		super();
		this.quantity = quantity;
		this.amount = amount;
		this.product = product;
	}
	public BigDecimal getAmount() {return amount;}
	public void setAmount(BigDecimal amount) {this.amount = amount;}
	public Product getProduct() {return product;}
	public void setProduct(Product product) {this.product = product;}
	public long getQuantity() {return quantity;}
	public void setQuantity(long quantity) {this.quantity = quantity;}

	public int getOrderId() {
		return orderId;
	}

	public void setOrderId(int orderId) {
		this.orderId = orderId;
	}

	public int getProductId() {
		return productId;
	}

	public void setProductId(int productId) {
		this.productId = productId;
	}
}
