package org.pwte.example.domain;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Set;

import zero.data.handler.Join;

import com.ibm.pdq.annotation.Column;
import com.ibm.pdq.annotation.GeneratedKey;
import com.ibm.pdq.annotation.Id;
import com.ibm.pdq.annotation.Table;


@Table(name="ORDER_")
public class Order implements Serializable {
	private static final long serialVersionUID = 7779370942277849463L;
	
	@Id
	@Column(name="ORDER_ID")
	protected int orderId;
	
	protected BigDecimal total;
	
	
	public static enum Status { OPEN, SUBMITTED, CLOSED }
	
	protected String status;
	protected AbstractCustomer customer;
	
	@Join
	protected Set<LineItem> lineitems;

	public AbstractCustomer getCustomer() {return customer;}
	public void setCustomer(AbstractCustomer customer) {this.customer = customer;}
	public Set<LineItem> getLineitems() {return lineitems;}
	public void setLineitems(Set<LineItem> lineitems) {this.lineitems = lineitems;}
	public int getOrderId() {return orderId;}
	public void setOrderId(int orderId) {this.orderId = orderId;}
	
	public String getStatus() {return status;}
	
	public void setStatus(String status) 
	{
		this.status = status;	
	}
	
	
	public BigDecimal getTotal() {return total;}
	public void setTotal(BigDecimal total) {this.total = total;}
}
