package org.pwte.example.domain;

import java.io.Serializable;
import java.util.Set;

import com.ibm.pdq.annotation.Column;
import com.ibm.pdq.annotation.Table;

@Table(name="CUSTOMER")
public class ResidentialCustomer extends AbstractCustomer implements Serializable {
	private static final long serialVersionUID = -8233689603226041269L;
	
	@Column(name="RESIDENTIAL_HOUSEHOLD_SIZE")
	protected short householdSize;
	
	@Column(name="RESIDENTIAL_FREQUENT_CUSTOMER")
	protected boolean frequentCustomer;
	
	public ResidentialCustomer(){super();}
	
	public ResidentialCustomer(short householdSize, boolean frequentCustomer, String name, Order openOrder, Set<Order> orders) {
		super(name, openOrder, orders);
		this.householdSize = householdSize;
		this.frequentCustomer = frequentCustomer;
	}
	public short getHouseholdSize() {return householdSize;}
	public void setHouseholdSize(short householdSize) {this.householdSize = householdSize;}
	public boolean isFrequentCustomer() {return frequentCustomer;}
	public void setFrequentCustomer(boolean frequentCustomer) {this.frequentCustomer = frequentCustomer;}
}
