package org.pwte.example.util;

import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Iterator;
import java.util.List;
import java.net.URLClassLoader;
import java.sql.Connection;

import junit.framework.TestCase;
import junit.framework.TestListener;

public class SampleUtil
{

  public static Connection getConnection (String url, String user, String pass)
  {
    Connection connection = null;

    try {
      Class.forName ("org.apache.derby.jdbc.ClientDriver").newInstance ();
     
      java.util.Properties info = new java.util.Properties ();
      info.put ("user", user);
      info.put ("password", pass);
      //info.put ("retrieveMessagesFromServerOnGetMessage", "true");

      connection = DriverManager.getConnection (url, info);
    }
    catch (Exception e) {
      e.printStackTrace ();
    }
    
    
    return connection;
  }


  public static void printAll (Iterator results)
  {
    Integer count = 0;

    while (results.hasNext ()) {
      Object o = results.next ();
      if (o == null) {
          printLn ("null");
      }
      else {
        printClass (o);
        count++;
      }
        printLn (count.toString ());
    }
  }

  public static void print (String message)
  {
	System.out.print (message);
  }

  public static void printLn (List<String[]> list)
  {
	for (String[] strArr : list) {
		System.out.println (strArr[0] + "," + strArr[1]);
	}
  }

  public static void printLn ()
  {
     System.out.println ();
  }

  public static void printLn (String message)
  {
     System.out.println (message);
  }

  public static void printClass (Object o)
  {
    Class cls = o.getClass ();
    print (cls.getSimpleName () + "[");
    Field[] fields = cls.getFields ();
    for (int x = 0; x < fields.length; x++) {
      print (fields[x].getName () + "=");
      Object value = null;
      try {
        if (Iterable.class.isAssignableFrom (fields[x].getType ())) {
          printLn ();
          List list = (List) fields[x].get (o);
          for (Iterator iter = list.iterator (); iter.hasNext ();) {
            printClass (iter.next ());
          }
        }
        else
          value = fields[x].get (o);
      }
      catch (Exception e) {
        e.printStackTrace ();
      }
	  if ( value != null)
    	  print (value.toString ());
      else
    	  print("null");
      if (x < fields.length - 1) {
        print (", ");
      }
    }
    Method[] methods = cls.getDeclaredMethods ();
    for (int x = 0; x < methods.length; x++) {
      if (!methods[x].getName ().startsWith ("get") || methods[x].getParameterTypes ().length > 0) continue;
      print (methods[x].getName () + "=");
      Object value = null;
      try {
        if (Iterable.class.isAssignableFrom (methods[x].getReturnType ())) {
          printLn ();
          List list = (List) methods[x].invoke (o);
          for (Iterator iter = list.iterator (); iter.hasNext ();) {
            printClass (iter.next ());
          }
        }
        else
          value = methods[x].invoke (o);
      }
      catch (Exception e) {
        e.printStackTrace ();
      }
      System.out.print (value);
      if (x < methods.length - 1) {
        print (", ");
      }
    }
    printLn ("]");
  }
  
 
}