
-------------------------------------------------- CONNECT TO DERBY --

connect 'jdbc:derby://localhost:1527/PWTE;create=true;';

-------------------------------------------------- DELETE DATA FROM TABLES --


DELETE FROM PRODUCT;
DELETE FROM LINE_ITEM;
UPDATE CUSTOMER SET OPEN_ORDER = NULL;
DELETE FROM ORDERS;
DELETE FROM CUSTOMER;



-------------------------------------------------- DROP KEYS --

ALTER TABLE "CUSTOMER" 

	DROP CONSTRAINT "CUSTOMER_KEY";

ALTER TABLE "LINE_ITEM" 

	DROP CONSTRAINT "LINE_ITEM_KEY";

ALTER TABLE "ORDERS" 

	DROP CONSTRAINT "ORDER_KEY" ;


ALTER TABLE "PRODUCT" 

	DROP CONSTRAINT "PRODUCT_KEY";

ALTER TABLE "CUSTOMER" 

	DROP CONSTRAINT "ORDER_FOREIGN1" ;

ALTER TABLE "LINE_ITEM" 

	DROP CONSTRAINT "ORDER_FOREIGN2" ;

ALTER TABLE "LINE_ITEM" 

	DROP CONSTRAINT "PRODUCT_FOREIGN";

ALTER TABLE "ORDERS" 

	DROP CONSTRAINT "CUSTOMER_FOREIGN" ;

-------------------------------------------------- DROP CONSTRAINTS --

ALTER TABLE "CUSTOMER" 

	DROP CONSTRAINT "BOOLEAN_CHECK";

ALTER TABLE "CUSTOMER" 

	DROP CONSTRAINT "SPARSE_TABLE_CHECK";

ALTER TABLE "ORDERS" 

	DROP CONSTRAINT "STATUS_ENUMERATION" ;
	
-------------------------------------------------- DROP TABLES --	
DROP TABLE  PRODUCT;
DROP TABLE  LINE_ITEM;
DROP TABLE  ORDERS;
DROP TABLE  CUSTOMER;

-------------------------------------------------- CREATE TABLES --

CREATE TABLE CUSTOMER  (
		  "CUSTOMER_ID" INTEGER NOT NULL , 
		  "OPEN_ORDER" INTEGER , 
		  "NAME" VARCHAR(30) NOT NULL , 
		  "BUSINESS_VOLUME_DISCOUNT" CHAR(1) DEFAULT 'N', 
		  "BUSINESS_PARTNER" CHAR(1) DEFAULT 'N', 
		  "BUSINESS_DESCRIPTION" CLOB(12582912) , 
		  "RESIDENTIAL_HOUSEHOLD_SIZE" SMALLINT , 
		  "RESIDENTIAL_FREQUENT_CUSTOMER" CHAR(1) DEFAULT 'Y',
		  
		  "TYPE" VARCHAR(11) NOT NULL );

CREATE TABLE LINE_ITEM  (
		  "ORDER_ID" INTEGER NOT NULL , 
		  "PRODUCT_ID" INTEGER NOT NULL , 
		  "QUANTITY" BIGINT NOT NULL , 
		  "AMOUNT" DECIMAL(14,2) NOT NULL );

CREATE TABLE ORDERS  (
		  "ORDER_ID" INTEGER NOT NULL generated always as identity, 
		  "CUSTOMER_ID" INTEGER NOT NULL , 
		  "STATUS" VARCHAR(9) NOT NULL , 
		  "TOTAL" DECIMAL(14,2) NOT NULL );

CREATE TABLE PRODUCT  (
		  "PRODUCT_ID" INTEGER NOT NULL, 
		  "PRICE" DECIMAL(14,2) NOT NULL , 
		  "DESCRIPTION" CLOB(12582912) NOT NULL );

------------------------------------------------ DEFINE PRIMARY/FOREIGN KEYS --

ALTER TABLE "CUSTOMER" 
	ADD CONSTRAINT "CUSTOMER_KEY" PRIMARY KEY
		("CUSTOMER_ID");

ALTER TABLE "LINE_ITEM" 
	ADD CONSTRAINT "LINE_ITEM_KEY" PRIMARY KEY
		("ORDER_ID",
		 "PRODUCT_ID");

ALTER TABLE "ORDERS" 
	ADD CONSTRAINT "ORDER_KEY" PRIMARY KEY
		("ORDER_ID");


ALTER TABLE "PRODUCT" 
	ADD CONSTRAINT "PRODUCT_KEY" PRIMARY KEY
		("PRODUCT_ID");

ALTER TABLE "CUSTOMER" 
	ADD CONSTRAINT "ORDER_FOREIGN1" FOREIGN KEY
		("OPEN_ORDER")
	REFERENCES "ORDERS"
		("ORDER_ID");

ALTER TABLE "LINE_ITEM" 
	ADD CONSTRAINT "ORDER_FOREIGN2" FOREIGN KEY
		("ORDER_ID")
	REFERENCES "ORDERS"
		("ORDER_ID");

ALTER TABLE "LINE_ITEM" 
	ADD CONSTRAINT "PRODUCT_FOREIGN" FOREIGN KEY
		("PRODUCT_ID")
	REFERENCES "PRODUCT"
		("PRODUCT_ID");

ALTER TABLE "ORDERS" 
	ADD CONSTRAINT "CUSTOMER_FOREIGN" FOREIGN KEY
		("CUSTOMER_ID")
	REFERENCES "CUSTOMER"
		("CUSTOMER_ID");

---------------------------------------------- CONSTRAINTS --

ALTER TABLE "CUSTOMER" 
	ADD CONSTRAINT "BOOLEAN_CHECK" CHECK 
		((BUSINESS_VOLUME_DISCOUNT = 'Y' OR BUSINESS_VOLUME_DISCOUNT = 'N') AND (BUSINESS_PARTNER
= 'Y' OR BUSINESS_PARTNER ='N') AND (RESIDENTIAL_FREQUENT_CUSTOMER = 'Y'
OR RESIDENTIAL_FREQUENT_CUSTOMER = 'N'));

ALTER TABLE "CUSTOMER" 
	ADD CONSTRAINT "SPARSE_TABLE_CHECK" CHECK 
		((BUSINESS_VOLUME_DISCOUNT ='Y' AND BUSINESS_PARTNER ='Y' AND
RESIDENTIAL_FREQUENT_CUSTOMER ='N') OR (BUSINESS_VOLUME_DISCOUNT = 'N'
 AND BUSINESS_PARTNER = 'N' AND RESIDENTIAL_FREQUENT_CUSTOMER = 'Y'));



ALTER TABLE "ORDERS" 
	ADD CONSTRAINT "STATUS_ENUMERATION" CHECK 
		(STATUS IN ('OPEN', 'SUBMITTED','CLOSED'));



 
---------------------------------------------- Disconnect --
disconnect;
exit;


